oauth_client_req_auth() authenticates a request using the authentication
strategy defined by the auth and auth_param arguments to oauth_client().
This is used to authenticate the client as part of the OAuth flow, not
to authenticate a request on behalf of a user.
There are three built-in strategies:
oauth_client_req_body() adds the client id and (optionally) the secret
to the request body, as described in Section 2.3.1 of RFC 6749.
oauth_client_req_header() adds the client id and secret using HTTP
basic authentication with the Authorization header, as described
in Section 2.3.1 of RFC 6749.
oauth_client_jwt_rs256() adds a client assertion to the body using a
JWT signed with jwt_sign_rs256() using a private key, as described
in Section 2.2 of RFC 7523.
You will generally not call these functions directly but will instead
specify them through the auth argument to oauth_client(). The req and
client parameters are automatically filled in; other parameters come from
the auth_params argument.
oauth_client_req_auth(req, client)
oauth_client_req_auth_header(req, client)
oauth_client_req_auth_body(req, client)
oauth_client_req_auth_jwt_sig(req, client, claim, size = 256, header = list())A httr2 request object.
An oauth_client.
Claim set produced by jwt_claim().
Size, in bits, of sha2 signature, i.e. 256, 384 or 512. Only for HMAC/RSA, not applicable for ECDSA keys.
A named list giving additional fields to include in the JWT header.
A modified HTTP request.
# Show what the various forms of client authentication look like
req <- request("https://example.com/whoami")
client1 <- oauth_client(
id = "12345",
secret = "56789",
token_url = "https://example.com/oauth/access_token",
name = "oauth-example",
auth = "body" # the default
)
# calls oauth_client_req_auth_body()
req_dry_run(oauth_client_req_auth(req, client1))
#> POST /whoami HTTP/1.1
#> accept: */*
#> accept-encoding: deflate, gzip, br, zstd
#> content-length: 35
#> content-type: application/x-www-form-urlencoded
#> host: example.com
#> user-agent: httr2/1.1.2 r-curl/7.0.0 libcurl/7.81.0
#>
#> client_id=12345&client_secret=56789
client2 <- oauth_client(
id = "12345",
secret = "56789",
token_url = "https://example.com/oauth/access_token",
name = "oauth-example",
auth = "header"
)
# calls oauth_client_req_auth_header()
req_dry_run(oauth_client_req_auth(req, client2))
#> GET /whoami HTTP/1.1
#> accept: */*
#> accept-encoding: deflate, gzip, br, zstd
#> authorization: <REDACTED>
#> host: example.com
#> user-agent: httr2/1.1.2 r-curl/7.0.0 libcurl/7.81.0
#>
client3 <- oauth_client(
id = "12345",
key = openssl::rsa_keygen(),
token_url = "https://example.com/oauth/access_token",
name = "oauth-example",
auth = "jwt_sig",
auth_params = list(claim = jwt_claim())
)
# calls oauth_client_req_auth_header_jwt_sig()
req_dry_run(oauth_client_req_auth(req, client3))
#> POST /whoami HTTP/1.1
#> accept: */*
#> accept-encoding: deflate, gzip, br, zstd
#> content-length: 623
#> content-type: application/x-www-form-urlencoded
#> host: example.com
#> user-agent: httr2/1.1.2 r-curl/7.0.0 libcurl/7.81.0
#>
#> client_assertion=eyJ0eXAiOiJKV1QiLCJhbGciOiJSUzI1NiJ9.eyJleHAiOjE3NjAwNDE0ODAsIm5iZiI6MTc2MDA0MTE4MCwiaWF0IjoxNzYwMDQxMTgwLCJqdGkiOiJfd3cwTk1INGlDRDZMVEhtNVdNOUZIcml4d0JfblpKYkZ4dm84TTUzYV80In0.i3T1e4Er9DlWekbz3XooQSIWXl1OeNSNUSSijQah0ss2vIwqR1v9v6GX3IPp7KHgJBXbdYAgeVR-YYquMbVJxlP_Ocbo9SKGGDTZOAeXUnAHFRBGHG9Iq9pq9D6eIkktaAEYmreIrh9pCjnQCvujSbhESAQxOgABdl6X3SGp1HCh-RmOZQy8v93kLCnR_hX1Z_d0wJusPa2MFOC_C8zTzY7Kr4ewWpnAteDqOjtgCYpnO9rsJ2iwOf0QeLR0ztdaueZCvWmkzq9H9sG8HTOw2Q7GMCsxXDjsll19jzx6eVpRZm-CEkvvrmb1sfdor_3fD3V0CeenjtqQtu2E3i-1fw&client_assertion_type=urn%3Aietf%3Aparams%3Aoauth%3Aclient-assertion-type%3Ajwt-bearer